<template>
  <div :style="{'height': thumbnailWidth, 'max-height': thumbnailWidth}">
    <div
      class="d-flex h-100"
      :style="{'gap': gap}"
    >
      <!-- Science -->
      <base-image
        :flip-y="true"
        :inverse="inverse"
        :src="scienceThumbnail.src"
        :height="thumbnailWidth"
        :width="thumbnailWidth"
      />
      <!-- Template -->
      <base-image
        :flip-y="true"
        :inverse="inverse"
        :src="templateThumbnail.src"
        :height="thumbnailWidth"
        :width="thumbnailWidth"
      />
      <!-- Difference -->
      <base-image
        :flip-y="true"
        :inverse="inverse"
        :src="differenceThumbnail.src"
        :height="thumbnailWidth"
        :width="thumbnailWidth"
      />
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';

import { AlertService } from '@/api';
import BaseImage from '@/components/BaseImage.vue';
import { Thumbnail } from '@/common/types';

export default Vue.extend({
  components: {
    BaseImage,
  },

  props: {
    alertId: {
      required: true,
      type: String,
    },
    gap: {
      default: '10px',
      type: String,
    },
    inverse: {
      default: true,
      type: Boolean,
    },
    thumbnailWidth: {
      default: '200px',
      type: String,
    },
  },

  data() {
    return {
      thumbnails: [] as Thumbnail[],
    };
  },

  computed: {
    scienceThumbnail(): Thumbnail | undefined {
      return this.thumbnails.find((t) => t.thumbnail_type === 'science');
    },
    differenceThumbnail(): Thumbnail | undefined {
      return this.thumbnails.find((t) => t.thumbnail_type === 'difference');
    },
    templateThumbnail(): Thumbnail | undefined {
      return this.thumbnails.find((t) => t.thumbnail_type === 'template');
    },
  },

  watch: {
    async alertId() {
      await this.fetchThumbnails();
    },
  },

  async mounted() {
    await this.fetchThumbnails();
  },

  methods: {
    async fetchThumbnails() {
      const { data: thumbnails } = await AlertService.listThumbnails(this.alertId, {});
      this.thumbnails = thumbnails;
    },
  },
});
</script>

<style scoped>
</style>
